package com.nbclass.activity.controller.keditor;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Map;
import java.util.Random;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.fileupload.FileItemFactory;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.apache.commons.lang3.StringUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import com.nbclass.aliyun.sdk.AliyunOSSUtils;
import com.nbclass.util.CommonUtils;

import lombok.extern.slf4j.Slf4j;
import net.coobird.thumbnailator.Thumbnails;  

/**
 * kindeditor上传文件 - 保存到阿里云OSS
 * @author Leon
 * @datetime 2020年6月8日 下午2:26:44
 */
@Slf4j
@RequestMapping("/console/kindeditor/oss")
@RestController
public class KindEditorUploadToOSSController {  
  
	// OSS保存目录
	private static final String upload_dir = "kindeditor-attached/";
	
	private static final long upload_max_size = 5242880; // 上传文件最大值，5M
	
    @PostMapping("/api/file-upload")
    public Map<String, Object> fileUpload(HttpServletRequest request, 
            HttpServletResponse response,@RequestParam("imgFile")MultipartFile file) 
            throws ServletException, IOException, FileUploadException {
    	response.setContentType("text/html; charset=UTF-8");
        String savePath = upload_dir;
        
        // 文件保存目录URL  
    //	String saveUrl = request.getContextPath() + "/keditor-attached/";  
        
        // 定义允许上传的文件扩展名  
        HashMap<String, String> extMap = new HashMap<String, String>();  
        extMap.put("image", "gif,jpg,jpeg,png,bmp");  
        extMap.put("flash", "swf,flv");  
        extMap.put("media", "swf,flv,mp3,wav,wma,wmv,mid,avi,mpg,asf,rm,rmvb,mp4,mov");		// 上传音视频格式
        extMap.put("file", "doc,docx,xls,xlsx,ppt,htm,html,txt,zip,rar,gz,bz2");  
        
        if (!ServletFileUpload.isMultipartContent(request)) {  
            return getError("请选择文件。");  
        }
        // 检查目录
        File uploadDir = new File(savePath);
        if (!uploadDir.isDirectory()){
        //	return getError("上传目录不存在。");  
           	uploadDir.mkdirs();
        }
        // 检查目录写权限
        if (!uploadDir.canWrite()){
            return getError("上传目录没有写权限。");  
        }
        
        String dirName = request.getParameter("dir");
        if (StringUtils.isBlank(dirName)) {
            dirName = "image";
        }
        if (!extMap.containsKey(dirName)) {
            return getError("目录名不正确。");
        }
        // 文件夹加上类型目录
        savePath += dirName + "/";
        // 文件夹加上日期目录
        savePath += CommonUtils.getSimpleDate(new Date(), "yyyyMM"); // yyyyMMdd
        
        FileItemFactory factory = new DiskFileItemFactory();  
        ServletFileUpload upload = new ServletFileUpload(factory);  
        upload.setHeaderEncoding("UTF-8");  
        //List items = upload.parseRequest(request);  
        //Iterator itr = items.iterator();  
        
        // FileItem item = (FileItem) itr.next();  
        String fileName = file.getOriginalFilename();
        
	    // 检查文件大小  
	    if (file.getSize() > upload_max_size) {
	        return getError("上传文件大小超过限制，请上传5M内的文件。");  
	    }
	    // 检查扩展名  
	    String fileExt = fileName.substring(fileName.lastIndexOf(".") + 1).toLowerCase();
	    if (!Arrays.<String> asList(extMap.get(dirName).split(",")).contains(fileExt)) {
	    	return getError("上传文件扩展名是不允许的扩展名。\n只允许" + extMap.get(dirName) + "格式。");  
	 	}
	    
	    String url = null;
	    String newFileName = CommonUtils.getSimpleDate(new Date(), "yyyyMMddHHmmss") + "_" + new Random().nextInt(1000) + "." + fileExt;
	    try {
	    //	File saveFile = new File(savePath+newFileName);
	    //	file.transferTo(saveFile);
	    // 	createThumbnail(savePath, newFileName);
	     	
	    	url = AliyunOSSUtils.uploadBytes(savePath, newFileName, file.getBytes());
	    	log.info("kindeditor上传文件到oss, url="+url);
	    	// 阿里云OSS缩略图，在URL后面加上：?x-oss-process=image/resize,m_fill,h_200,w_200
	    } catch (Exception e) {
	    	e.printStackTrace();
	    	return getError("上传文件失败。");  
	    }
	    
	    Map<String, Object> msg = new HashMap<String, Object>();
	    msg.put("error", 0);
	    msg.put("url", url);
	    return msg;
    }
	
    private Map<String, Object> getError(String message) {  
        Map<String, Object> msg = new HashMap<String, Object>();  
        msg.put("error", 1);  
        msg.put("message", message);  
        return msg;  
    }    
    
	/**
	 * @param savePath
	 * @param newFileName
	 */
    
	@SuppressWarnings("unused")
	private void createThumbnail(String savePath, String newFileName) {
		try {
			Thumbnails.of(savePath+newFileName)   
			.size(200,200)  
			.toFile(savePath+"thump"+newFileName);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
  
    @SuppressWarnings("rawtypes")
	class NameComparator implements Comparator {  
        public int compare(Object a, Object b) {  
            Hashtable hashA = (Hashtable) a;  
            Hashtable hashB = (Hashtable) b;  
            if (((Boolean) hashA.get("is_dir"))  
                    && !((Boolean) hashB.get("is_dir"))) {  
                return -1;  
            } else if (!((Boolean) hashA.get("is_dir"))  
                    && ((Boolean) hashB.get("is_dir"))) {  
                return 1;  
            } else {  
                return ((String) hashA.get("filename"))  
                        .compareTo((String) hashB.get("filename"));  
            }  
        }  
    }  
  
    @SuppressWarnings("rawtypes")
	class SizeComparator implements Comparator {  
        public int compare(Object a, Object b) {  
            Hashtable hashA = (Hashtable) a;  
            Hashtable hashB = (Hashtable) b;  
            if (((Boolean) hashA.get("is_dir"))  
                    && !((Boolean) hashB.get("is_dir"))) {  
                return -1;  
            } else if (!((Boolean) hashA.get("is_dir"))  
                    && ((Boolean) hashB.get("is_dir"))) {  
                return 1;  
            } else {  
                if (((Long) hashA.get("filesize")) > ((Long) hashB  
                        .get("filesize"))) {  
                    return 1;  
                } else if (((Long) hashA.get("filesize")) < ((Long) hashB  
                        .get("filesize"))) {  
                    return -1;  
                } else {  
                    return 0;  
                }  
            }  
        }  
    }
    
    @SuppressWarnings("rawtypes")
	class TypeComparator implements Comparator {  
        public int compare(Object a, Object b) {  
            Hashtable hashA = (Hashtable) a;  
            Hashtable hashB = (Hashtable) b;  
            if (((Boolean) hashA.get("is_dir"))  
                    && !((Boolean) hashB.get("is_dir"))) {  
                return -1;  
            } else if (!((Boolean) hashA.get("is_dir"))  
                    && ((Boolean) hashB.get("is_dir"))) {  
                return 1;  
            } else {  
                return ((String) hashA.get("filetype"))  
                        .compareTo((String) hashB.get("filetype"));  
            }  
        }  
    }  
  
}  
